Subject: Re: [PATCH gnome-team v3 2/5] build: gnu: Export a %gnu-default-modules variable.

From: Bruno Victal <[email-masked]>
Date: Tue, 20 Jun 2023 07:59:22 +0100

Hi Liliana,

On 2023-06-20 05:18, Liliana Marie Prikler wrote:
> Am Montag, dem 19.06.2023 um 23:07 +0100 schrieb Bruno Victal:
>> This makes tweaking the #:module argument less reliant on the
>> programmers astral wisdom to divine the right module imports.
>>
>> * guix/build-system/gnu.scm (%default-modules): Rename to …
>> (%gnu-default-modules): … this and export it as well.
>> ---
> Uhm, is this required?  I see it used in xdgmime, but I'd very much
> like to do without it.

As indicated in the commit message, its purpose is to make things
easier. (I've taken inspiration from elm-build-system here)

I think the most compelling arguments to this approach is that in
some packages you see things like:

--8<---------------cut here---------------start------------->8---
gnu/packages/boost.scm-     (list
gnu/packages/boost.scm:      #:imported-modules `((guix build python-build-system)
gnu/packages/boost.scm-                           ,@%gnu-build-system-modules)
gnu/packages/boost.scm:      #:modules `(((guix build python-build-system) #:select (python-version))
gnu/packages/boost.scm-                  ,@%gnu-build-system-modules)
gnu/packages/boost.scm-      #:tests? #f
gnu/packages/boost.scm-      #:configure-flags
--8<---------------cut here---------------end--------------->8---

Which is most likely a mistake since the actual #:module should
be about %default-modules which is a subset of %gnu-build-system-modules.
(albeit one with seemingly little impact)

The divination comment stems from the following reasoning:
“How can I know what gnu-build-system actually imports if not by
guessing/cargo-culting or peering at the private %default-modules?“
(at that point, why not export it as well?)

I'd argue it's a nice addition though strictly speaking its not fundamental
for this patch-series and can be left out, by manually expanding the
%gnu-default-modules value in the xdgmime arguments.

-- 
Furthermore, I consider that nonfree software must be eradicated.

Cheers,
Bruno.